# -*- coding: utf-8 -*-

from netkit.box import Box
from collections import OrderedDict

# 如果header字段变化，那么格式也会变化
HEADER_ATTRS = OrderedDict([
    ('magic', ('i', 2037952207)),
    ('version', ('h', 0)),
    ('inner', ('h', 0)),
    ('packet_len', ('i', 0)),
    ('cmd', ('i', 0)),
    ('ret', ('i', 0)),
    ('conn_id', ('q', 0)),
    ('uid', ('i', 0)),
    ('conn_ptr', ('q', 0)),
    ('tag', ('i', 0)),
    ])


class GWBox(Box):
    header_attrs = HEADER_ATTRS

    def map(self, map_data):
        """
        获取对应的response
        :param : map_data
        :return:
        """
        assert isinstance(map_data, dict)

        init_data = dict(
            conn_id=self.conn_id,
            conn_ptr=self.conn_ptr,
            tag=self.tag,
        )
        init_data.update(map_data)

        return self.__class__(init_data)
